#version 330                                                                        
                                                                                                                                            
                                                                                    
in vec2 TexCoord;   
in float TTL0;                                                                
out vec4 FragColor;    

uniform int fireworks;     
uniform float brightness;


float rand(vec2 co){
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453) - 0.5;
}
float noise(vec2 p){
	vec2 ip = floor(p);
	vec2 u = fract(p);
	u = u*u*(3.0-2.0*u);

	float res = mix(
		mix(rand(ip),rand(ip+vec2(1.0,0.0)),u.x),
		mix(rand(ip+vec2(0.0,1.0)),rand(ip+vec2(1.0,1.0)),u.x),u.y);
	return res*res;
}                                                        
                                                                                                                                                                                                                                           
vec3 pow3(vec3 v, float p) { 
	return pow(abs(v), vec3(p)); 
}

vec3 glowSphere(vec3 color, vec2 p, float radius, float glow) {
	// Inspired by https://www.shadertoy.com/view/4lfXRf
	float term = 1./length(p)/5.;
	return pow3(color * term * 0.5, glow) * radius;
}


void main() {
	vec3 baseColor = vec3(1, 1, 0);
	if(fireworks == 1){
		baseColor = vec3(0.5 * noise(vec2(TTL0 + 1, TTL0)), 0.5 * noise(vec2(TTL0 + 0.5, TTL0)),0.5 * noise(vec2(TTL0 * 2, TTL0)));
	}
	vec3 color = glowSphere(baseColor, TexCoord * 2 - 1, 50000000, 3.25);
	float lum = dot(color, vec3(0.299, 0.587, 0.114));
	FragColor = vec4(color, lum); // use luminance as alpha
	FragColor.rgb = FragColor.rgb * brightness;
}
                                                                              