#version 330

layout (points) in; // points in
layout (triangle_strip, max_vertices = 4) out; // quads out


uniform mat4 ProjectionMatrix;
uniform int fireworks; 

out vec2 TexCoord;
out float TTL0;

void main () {

vec2 size = vec2(0.05, 0.05);
if(fireworks == 1){
	size = vec2(0.12, 0.12);
}


vec4 P = vec4(gl_in[0].gl_Position.xyz, 1); // position in view-space
vec2 va = P.xy + vec2(-0.5, -0.5) * size; // bottom-left corner
gl_Position = ProjectionMatrix * vec4(va, P.zw);
TTL0 = gl_in[0].gl_Position.w;
TexCoord = vec2(0.0, 0.0);
EmitVertex();

va = P.xy + vec2(0.5, -0.5) * size; // bottom-right corner
gl_Position = ProjectionMatrix * vec4(va, P.zw);
TTL0 = gl_in[0].gl_Position.w;
TexCoord = vec2(1.0, 0.0);
EmitVertex();

va = P.xy + vec2(-0.5, 0.5) * size; // top-left corner
gl_Position = ProjectionMatrix * vec4(va, P.zw);
TTL0 = gl_in[0].gl_Position.w;
TexCoord = vec2(0.0, 1.0);
EmitVertex();

va = P.xy + vec2(0.5, 0.5) * size; // top-right corner
gl_Position = ProjectionMatrix * vec4(va, P.zw);
TTL0 = gl_in[0].gl_Position.w;
TexCoord = vec2(1.0, 1.0);
EmitVertex();



EndPrimitive();
}