#version 330

layout(points) in;
layout(points) out;
layout(max_vertices = 30) out;

in vec4 Position0[];
in vec4 Velocity0[];

out vec4 Position1;
out vec4 Velocity1;

uniform float DeltaT;
uniform vec4 spawn;
uniform int firework;

const vec3 GRAVITY = vec3(0, -9.81f, 0);

float rand(vec2 co){
    return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453) - 0.5;
}

float noise(vec2 p){
	vec2 ip = floor(p);
	vec2 u = fract(p);
	u = u*u*(3.0-2.0*u);

	float res = mix(
		mix(rand(ip),rand(ip+vec2(1.0,0.0)),u.x),
		mix(rand(ip+vec2(0.0,1.0)),rand(ip+vec2(1.0,1.0)),u.x),u.y);
	return res*res;
}

void main(){

	float TTL = Position0[0].w - DeltaT;
	vec4 hashvec = vec4(Velocity0[0]);
	float hash = (hashvec.x + hashvec.y) * hashvec.w;
	if(TTL > 0){
		
		Velocity1 = vec4(Velocity0[0].xyz + DeltaT * GRAVITY, 0);
		gl_Position = vec4(Position0[0].xyz + DeltaT * Velocity1.xyz, TTL);
		Position1 = gl_Position;
		EmitVertex();
		EndPrimitive();
		
	}else{
		if(firework == 0){
			Velocity1 = vec4(rand(3 * hashvec.zy), 3 + 3 * rand(hashvec.zy), 1 * rand(hashvec.xy), 0);
			gl_Position = spawn;
			Position1 = gl_Position;
			EmitVertex();
			EndPrimitive();
		}
		else{
			Velocity1 = vec4(5 * rand(vec2(noise(hashvec.zy),rand(hashvec.xy))), 5 + 5 * rand(hashvec.zy), 5 * rand(vec2(noise(hashvec.xy), rand(hashvec.xy))), 0);
			gl_Position = vec4(spawn.xyz, 3);
			Position1 = gl_Position;
			EmitVertex();
			EndPrimitive();
		}
	}
	
	

	
	
	
}
