#version 430
/*
* Copyright 2010 Vienna University of Technology.
* Institute of Computer Graphics and Algorithms.
* This file is part of the ECG Lab Framework and must not be redistributed.
*/

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;


out VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec2 uv;
} vert;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;
uniform mat3 normalMatrix;
uniform float time;
uniform int isWater;

void main() {
	vert.normal_world = normalMatrix * normal;
	vert.uv = uv;
	vec4 position_world_;
	if(isWater == 0){
		position_world_ = modelMatrix * vec4(position, 1);
	}else{
		vec3 position_ = position + (( 0.3 * sin(20* uv[1] + time * 0.6) + 0.3 * sin(40* uv[0] + time * 0.6) ) * normal);
		position_world_ = modelMatrix * vec4(position_ , 1);
		float grad_x = (0.3 * cos(20* uv[1] + time * 0.6) + 0.3 * sin(40* uv[0] + time * 0.6));
		float grad_z = (0.3 * sin(20* uv[1] + time * 0.6) + 0.3 * cos(40* uv[0] + time * 0.6));
		vert.normal_world =  normalMatrix * normalize(vec3(-grad_x, 1, -grad_z));
	}
	vert.position_world = position_world_.xyz;
	gl_Position = viewProjMatrix * position_world_;
}